/*
	Black Jack for CASIO fx-9860G
	C
*/

#include <stdio.h>
#include "bj.h"

static unsigned char pileCard[52 * DECKS];
static int pileCardCount;

/*
	J[hRɖ߂Vbt ()
*/
static void shufflePile(void)
{
	int i, suit, rank;
	unsigned char tmp, *p, *q;

	srand(getSeed());

	p = pileCard;
	for(i = 0; i < DECKS; i++)
		for(suit = SUIT_FIRST; suit <= SUIT_LAST; suit++)
			for(rank = RANK_FIRST; rank <= RANK_LAST; rank++)
				*p++ = MAKE_CARD(suit, rank);

	for(p = pileCard; p < pileCard + 52 * DECKS; p++) {
		q = pileCard + rand() % (52 * DECKS);
		tmp = *p;
		*p = *q;
		*q = tmp;
	}

	pileCardCount = 52 * DECKS;
}

/*
	J[h̓_𓾂 ()
*/
static int getValue(unsigned char card)
{
	int rank = RANK(card);

	if(rank == RANK_ACE)
		return 11;
	else if(rank >= RANK_JACK)
		return 10;
	else
		return rank + 2;
}

/*
	J[hRĔz ()
*/
static unsigned char dealCard(int person, int pos, int show, int *value, int *soft_count)
{
	int rank, v;
	unsigned char card;

	card = pileCard[--pileCardCount];

	if(pos >= 0)
		putCard(person, pos, card, (show ? PUTCARD_PUT: PUTCARD_TAIL));
	if(value != NULL) {
		if((v = getValue(card)) == 11)
			(*soft_count)++;

		*value += v;
		if(*value > 21 && *soft_count > 0) {
			*value -= 10;
			(*soft_count)--;
		}
	}
	if(show)
		printValue(person, *value);

	if(pos >= 0)
		delay(3);
	return card;
}

/*
	J[h ()
*/
static void showCard(int person, int pos, unsigned char card, int value)
{
	putCard(person, pos, card, PUTCARD_PUT);
	printValue(person, value);
	delay(3);
}

/*
	SẴJ[h ()
*/
static void unputAll(int person)
{
	int pos;

	for(pos = 0; pos < 6; pos++)
		putCard(person, pos, 0, PUTCARD_UNPUT);
}

/*
	1v[ ()
*/
int game(int tip, int bet)
{
	int i;
	int first = TRUE;
	int dealer_pos = 0;
	int player_pos = 0;
	int dealer_value = 0, dealer_soft_count = 0;
	int player_value[DECKS * 4 - 1], player_soft_count;
	int play;
	int insurance;
	int player_card_count[DECKS * 4 - 1];
	int split_count = 0;
	int play_count = 0;
	unsigned int play_mask;
	unsigned char dealer_card1, dealer_card2;
	unsigned char player_card1, player_card2, split_card[DECKS * 4 - 1];

	cls();

	tip -= bet;
	play_mask = PLAY_HIT_MASK | PLAY_STAY_MASK | PLAY_SURRENDER_MASK;

	/* e2z */
	dealer_card1 = dealCard(PERSON_DEALER, dealer_pos++, TRUE, &dealer_value, &dealer_soft_count);
	dealer_card2 = dealCard(PERSON_DEALER, dealer_pos, FALSE, &dealer_value, &dealer_soft_count);

	/* q1ڂz */
	player_card1 = dealCard(PERSON_PLAYER, -1, 0, NULL, NULL);
split:;
	player_pos = 0;
	player_value[play_count] = getValue(player_card1);
	player_soft_count = (player_value[play_count] == 11 ? 1: 0);
	printMessage("");
	unputAll(PERSON_PLAYER);
	showCard(PERSON_PLAYER, player_pos++, player_card1, player_value[play_count]);

	/* q2ڂz */
	player_card2 = dealCard(PERSON_PLAYER, player_pos++, TRUE, &player_value[play_count], &player_soft_count);

	if (first) {
		first = FALSE;

		/* CVAX邩? */
		insurance = (RANK(dealer_card1) == RANK_ACE && tip >= bet / 2 && inputPlay(PLAY_INSURANCE_MASK | PLAY_NO_MASK) == PLAY_INSURANCE);
		if (insurance)
			tip -= bet / 2;

		/* eubNWbN? */
		if(dealer_value == 21) {
			if(insurance)
				tip += (bet / 2) + (bet / 2) * 2;

			/* ẽJ[hI[v */
			printMessage("BLACKJACK");
			showCard(PERSON_DEALER, dealer_pos++, dealer_card2, dealer_value);
			delay(5);

			/* qubNWbN? */
			if(player_value[0] == 21)
				tip += bet;

			return tip;
		}

		/* _u_Eł邩? */
		play_mask |= (tip >= bet ? PLAY_DOUBLE_MASK: 0);
	}

	if(player_value[play_count] == 21) {
		/* 21 */
		delay(4);
	} else if(play_count > 0 && RANK(player_card1) == RANK_ACE) {
		/* ÃXvbg */
		delay(16);
	} else {
		/* Xvbgł邩? */
		play_mask |= (RANK(player_card1) == RANK(player_card2) && tip >= bet ? PLAY_SPLIT_MASK: 0);

		/* q̃v[ */
		while(player_value[play_count] < 21) {
			play = inputPlay(play_mask);
			play_mask &= ~(PLAY_DOUBLE_MASK | PLAY_SPLIT_MASK | PLAY_SURRENDER_MASK);

			if(play == PLAY_HIT) {
				/* qbg */
				dealCard(PERSON_PLAYER, player_pos++, TRUE, &player_value[play_count], &player_soft_count);
			} else if(play == PLAY_STAY) {
				/* XeC */
				break;
			} else if(play == PLAY_DOUBLE) {
				/* _u_E */
				dealCard(PERSON_PLAYER, player_pos++, TRUE, &player_value[play_count], &player_soft_count);
				tip -= bet;
				bet *= 2;
				break;
			} else if(play == PLAY_SPLIT) {
				/* Xvbg */
				tip -= bet;
				split_card[split_count++] = player_card2;
				goto split;
			} else if(play == PLAY_SURRENDER) {
				/* T_[ */
				tip += bet / 2;
				return tip;
			}
		}
	}
	player_card_count[play_count] = player_pos;
	if (player_value[play_count] > 21) {
		printMessage("   BUST!");
		delay(6);
	}

	play_count++;

	/* XvbgJ[hcĂ邩? */
	if(split_count > 0) {
		player_card1 = split_card[--split_count];
		goto split;
	}

	/* qubNWbN? */
	if (play_count == 1 && player_value[0] == 21 && player_card_count[0] == 2) {
		printMessage("BLACK JACK!");
		delay(10);
		tip += (bet * 2 + bet / 2) * play_count;
		return tip;
	}

	/* qSăo[Xg? */
	for(i = 0; i < play_count; i++)
		if(player_value[i] <= 21)
			break;
	if(i == play_count)
		return tip;

	/* ẽJ[hI[v */
	showCard(PERSON_DEALER, dealer_pos++, dealer_card2, dealer_value);

	/* ẽv[ */
	while(dealer_value <= 16)
		dealCard(PERSON_DEALER, dealer_pos++, TRUE, &dealer_value, &dealer_soft_count);
	if(dealer_value > 21) {
		printMessage("   BUST!");
		delay(6);
	}

	/* _r */
	for(i = 0; i < play_count; i++) {
		if(player_value[i] > 21) {
			/* ȅ */
		} else if(dealer_value > 21 || dealer_value < player_value[i]) {
			/* q̏ */
			tip += bet * 2;
		} else if(dealer_value > player_value[i]) {
			/* ȅ */
		} else {
			/*  */
			tip += bet;
		}
	}

	return tip;
}

/*
	|߂
*/
int money(int *tip, int *bet, int *count)
{
	int mask;
	int play;

	cls();

	do {
		mask = 0;
		if(*bet >= *tip)
			*bet = *tip;
		else if(*bet >= 20)
			*bet = 20;
		else
			mask = PLAY_INC_MASK;

		if(*bet <= 2)
			*bet = 2;
		else
			mask |= PLAY_DEC_MASK;

		printTip(*tip, *bet, *count);

		play = inputPlay(PLAY_PLAY_MASK | PLAY_INIT_MASK | mask);
		if(play == PLAY_INC)
			(*bet)++;
		else if(play == PLAY_DEC)
			(*bet)--;
		else if(play == PLAY_INIT) {
			if(inputPlay(PLAY_YES_MASK | PLAY_NO_MASK) == PLAY_YES)
				return FALSE;
		}
	} while(play != PLAY_PLAY);

	(*count)++;

	return TRUE;
}

/*
	Q[I[o[
*/
void gameover(int count)
{
	delete();
	cls();
	printTip(-1, -1, count);
	printMessage(" GAME OVER");
}

/*
	C[v
*/
void mainLoop(void)
{
	const unsigned char *msg[] = {
		"  You Win!",
		"   I Win.",
		"    Tie."
	};
	int tip, bet, count, result;

	for(;;) {
		resume(&tip, &bet, &count);
		if(count == 0)
			pileCardCount = 0;

		while (tip >= 2) {
			if(pileCardCount < DECKS * 52 / 3) {
				cls();
				printMessage("SHUFFLING..");
				delay(10);
				pileCardCount = 0;
			}

			if(!money(&tip, &bet, &count))
				break;

			if(pileCardCount == 0)
				shufflePile();

			store(tip - bet, bet, count);
			result = game(tip, bet);
			printMessage(msg[tip < result ? 0: (tip > result ? 1: 2)]);

			tip = result;
			store(tip, bet, count);
			pause();
		}

		gameover(count);
		pause();
	}
}

/*
	Copyright 2010 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */