/*
	Black Jack for CASIO fx-9860G
	ˑ
*/

#include <stdio.h>
#include "fxlib.h"
#include "dispbios.h"
#include "graph.h"
#include "timer.h"
#include "bj.h"

#define SCREEN_WIDTH	128
#define SCREEN_HEIGHT	64

#define GRAPHDATA_SPADE	0
#define GRAPHDATA_HEART	1
#define GRAPHDATA_DIAMOND	2
#define GRAPHDATA_CLUB	3
#define GRAPHDATA_TWO	4
#define GRAPHDATA_THREE	5
#define GRAPHDATA_FOUR	6
#define GRAPHDATA_FIVE	7
#define GRAPHDATA_SIX	8
#define GRAPHDATA_SEVEN	9
#define GRAPHDATA_EIGHT	10
#define GRAPHDATA_NINE	11
#define GRAPHDATA_TEN	12
#define GRAPHDATA_JACK	13
#define GRAPHDATA_QUEEN	14
#define GRAPHDATA_KING	15
#define GRAPHDATA_ACE	16
#define GRAPHDATA_TAIL	17
#define GRAPHDATA_HIT	18
#define GRAPHDATA_STAY	19
#define GRAPHDATA_DOUBLE	20
#define GRAPHDATA_SPLIT	21
#define GRAPHDATA_SURRENDER	22
#define GRAPHDATA_INSURANCE	23
#define GRAPHDATA_NOT	24
#define GRAPHDATA_INIT	25
#define GRAPHDATA_INIT_REALLY	26

#define SAVE_FILE_NAME	((unsigned char *)"bj")

static int seed = 0;

/*
	҂
*/
void delay(int val)
{
	Bdisp_PutDisp_DD();
	Sleep(1);
	Sleep(val * 100);
}

/*
	ʂ
*/
void cls(void)
{
		Bdisp_AllClr_DDVRAM();
}

/*
	180x]p^[𓾂 ()
*/
static GRAPHDATA rotateGraphData(GRAPHDATA *out, const GRAPHDATA *in)
{
	const char rev[] = {
		0x0 | 0x0 | 0x0 | 0x0,
		0x8 | 0x0 | 0x0 | 0x0,
		0x0 | 0x4 | 0x0 | 0x0,
		0x8 | 0x4 | 0x0 | 0x0,
		0x0 | 0x0 | 0x2 | 0x0,
		0x8 | 0x0 | 0x2 | 0x0,
		0x0 | 0x4 | 0x2 | 0x0,
		0x8 | 0x4 | 0x2 | 0x0,
		0x0 | 0x0 | 0x0 | 0x1,
		0x8 | 0x0 | 0x0 | 0x1,
		0x0 | 0x4 | 0x0 | 0x1,
		0x8 | 0x4 | 0x0 | 0x1,
		0x0 | 0x0 | 0x2 | 0x1,
		0x8 | 0x0 | 0x2 | 0x1,
		0x0 | 0x4 | 0x2 | 0x1,
		0x8 | 0x4 | 0x2 | 0x1
	};
	int x, y, n;
	unsigned char *p;
	const unsigned char *q;

	n = ((in->width + 7) / 8) * in->height;
	out->width  = in->width;
	out->height = in->height;
	for(p = out->pBitmap, q = in->pBitmap + n - 1; p < out->pBitmap + n; p++, q--)
		*p = rev[*q >> 4] | (rev[*q & 0x0f] << 4);

	return *out;
}

/*
	J[h\ ()
*/
static void _putCard(int col, int row, unsigned char card, int mode)
{
	DISPBOX area;
	DISPGRAPH disp;
	GRAPHDATA buf;
	int top, bottom;
	unsigned char _buf[8];

	top    = (row - 1) * 8;
	bottom = top + 40 - 1;
	area.left   = (col - 1) * 6;
	area.top    = MAX(top, 0);
	area.right  = area.left + 24 - 1;
	area.bottom = MIN(bottom, (SCREEN_HEIGHT - 9) - 1);

	/* J[h */
	Bdisp_AreaClr_VRAM(&area);
	if (mode == PUTCARD_UNPUT)
		return;

	/* J[h̘g\ */
	if(top >= 0)
		Bdisp_DrawLineVRAM(area.left, area.top, area.right, area.top);
	if(bottom < SCREEN_HEIGHT - 9)
		Bdisp_DrawLineVRAM(area.left,  area.bottom, area.right, area.bottom);
	Bdisp_DrawLineVRAM(area.left,  area.top, area.left,  area.bottom);
	Bdisp_DrawLineVRAM(area.right, area.top, area.right, area.bottom);

	disp.WriteModify = IMB_WRITEMODIFY_NORMAL;
	disp.WriteKind   = IMB_WRITEKIND_OR;

	if(mode == PUTCARD_TAIL) {
		/* J[h̗\ */
		disp.GraphData = graphData[GRAPHDATA_TAIL];
		for(disp.y = area.top; disp.y < area.bottom; disp.y += 8)
			for(disp.x = area.left; disp.x < area.right; disp.x += 8)
				Bdisp_WriteGraph_VRAM(&disp);
		return;
	}

	/* J[h̍̃N\ */
	disp.x = area.left;
	disp.y = top;
	disp.GraphData = graphData[RANK(card) + GRAPHDATA_TWO];
	Bdisp_WriteGraph_VRAM(&disp);

	/* J[h̍̃X[c\ */
	disp.y += 8;
	disp.GraphData = graphData[SUIT(card) + GRAPHDATA_SPADE];
	Bdisp_WriteGraph_VRAM(&disp);

	buf.pBitmap = _buf;

	/* J[h̉ẼX[c\ */
	disp.y = (bottom + 1) - 16;
	if(disp.y >= SCREEN_HEIGHT - 9)
		return;
	disp.x = (area.right + 1) - 8;
	disp.GraphData = rotateGraphData(&buf, &graphData[SUIT(card) + GRAPHDATA_SPADE]);
	Bdisp_WriteGraph_VRAM(&disp);

	/* J[h̉ẼN\ */
	disp.y += 8;
	if(disp.y >= SCREEN_HEIGHT - 9)
		return;
	disp.GraphData = rotateGraphData(&buf, &graphData[RANK(card) + GRAPHDATA_TWO]);
	Bdisp_WriteGraph_VRAM(&disp);
}

/*
	e܂͎q̃J[h\
*/
void putCard(int person, int pos, unsigned char card, int mode)
{
	if(person == PERSON_DEALER)
		_putCard(18 - pos * 2, -1, card, mode);
	else
		_putCard(1 + pos * 2, 5, card, mode);
}

/*
	bZ[W\
*/
void printMessage(const unsigned char *buf)
{
	locate(6, 4);
	Print((unsigned char *)"           ");
	locate(6, 4);
	Print(buf);
	Bdisp_PutDisp_DD();
}

/*
	l(2)𕶎ɂ ()
*/
static unsigned char *_writeNumber2(unsigned char *buf, int num, int zero)
{
	if(num / 10 > 0 || zero >= 2)
		buf[0] = '0' + (num / 10);
	else
		buf[0] = ' ';
	if(num % 10 > 0 || zero >= 1)
		buf[1] = '0' + (num % 10);
	else
		buf[1] = ' ';
	buf[2] = 0;

	return buf;
}

/*
	l(2)𕶎ɂ ()
*/
static unsigned char *writeNumber2(unsigned char *buf, int num)
{
	_writeNumber2(buf, num, 1);
	return buf;
}

/*
	l(4)𕶎ɂ ()
*/
static unsigned char *writeNumber4(unsigned char *buf, int num)
{
	_writeNumber2(buf, num / 100, 0);
	_writeNumber2(buf + 2, num % 100, (num / 100 > 0 ? 2: 1));
	return buf;
}

/*
	_(2)\
*/
void printValue(int person, int value)
{
	const int x[] = { 18, 1 };
	unsigned char buf[3];

	locate(x[person], 4);
	Print((unsigned char *)"[  ]");
	locate(x[person] + 1, 4);
	Print(writeNumber2(buf, value));
}

/*
	, |, v[񐔂\
*/
void printTip(int tip, int bet, int count)
{
	unsigned char buf[5];

	locate(7, 2);
	Print((unsigned char *)"\x1bLACKJACK");

	if(tip >= 0) {
		locate(6, 4);
		Print((unsigned char *)"Tip [    ]$");
		locate(11, 4);
		Print(writeNumber4(buf, tip));
	}

	if(bet >= 0) {
		locate(6, 5);
		Print((unsigned char *)"Bet   [  ]$");
		locate(13, 5);
		writeNumber2(buf, bet);
		Print(buf);
	}

	locate(6, 6);
	Print((unsigned char *)"Play[    ]");
	locate(11, 6);
	Print(writeNumber4(buf, count));
}

/*
	͂𓾂
*/
int inputPlay(unsigned int mask)
{
	const unsigned int fkey[] = {
		KEY_CTRL_F1,	/* PLAY_HIT */
		KEY_CTRL_F2,	/* PLAY_STAY */
		KEY_CTRL_F3,	/* PLAY_DOUBLE */
		KEY_CTRL_F4,	/* PLAY_SPLIT */
		KEY_CTRL_F5,	/* PLAY_SURRENDER */
		KEY_CTRL_F3,	/* PLAY_INSURANCE */
		KEY_CTRL_F4,	/* PLAY_NOT */
		KEY_CTRL_F1,	/* PLAY_PLAY */
		KEY_CTRL_F2,	/* PLAY_DEC */
		KEY_CTRL_F3,	/* PLAY_INC */
		KEY_CTRL_F6,	/* PLAY_INIT */
		KEY_CTRL_F3	/* PLAY_INIT_REALLY */
	};
	const int x[] = {
		22 * 0,	/* PLAY_HIT */
		22 * 1,	/* PLAY_STAY */
		22 * 2,	/* PLAY_DOUBLE */
		22 * 3,	/* PLAY_SPLIT */
		22 * 4,	/* PLAY_SURRENDER */
		22 * 2,	/* PLAY_INSURANCE */
		22 * 3,	/* PLAY_NOT */
		22 * 0,	/* PLAY_PLAY */
		22 * 1,	/* PLAY_DEC */
		22 * 2,	/* PLAY_INC */
		22 * 5,	/* PLAY_INIT */
		22 * 2	/* PLAY_INIT_REALLY */
	};
	const DISPBOX area = { 0, SCREEN_HEIGHT - 8, SCREEN_WIDTH - 1, SCREEN_HEIGHT - 1 };
	DISPGRAPH disp;
	int play;
	unsigned int k;

	disp.y = SCREEN_HEIGHT - 8;
	disp.WriteModify = IMB_WRITEMODIFY_NORMAL;
	disp.WriteKind   = IMB_WRITEKIND_OR;

	Bdisp_AreaClr_VRAM(&area);
	for(play = 0; play < sizeof(fkey) / sizeof(fkey[0]); play++)
		if(mask & (1U << play)) {
			disp.x = x[play];
			disp.GraphData = graphData[GRAPHDATA_HIT + play];
			Bdisp_WriteGraph_VRAM(&disp);
		}

	for(;;) {
		GetKey(&k);
		for(play = 0; play < sizeof(fkey) / sizeof(fkey[0]); play++)
			if((mask & (1U << play)) && k == fkey[play]) {
				Bdisp_AreaReverseVRAM(x[play], disp.y, x[play] + graphData[GRAPHDATA_HIT + play].width, disp.y + graphData[GRAPHDATA_HIT + play].height);
				delay(2);
				Bdisp_AreaReverseVRAM(x[play], disp.y, x[play] + graphData[GRAPHDATA_HIT + play].width, disp.y + graphData[GRAPHDATA_HIT + play].height);
				return play;
			}
	}
}

/*
	L[͂҂
*/
void pause(void)
{
	unsigned int key;

	GetKey(&key);
}

/*
	Q[Ԃ𕜋A
*/
int resume(int *tip, int *bet, int *count)
{
	int h;

	if((h = Bfile_OpenMainMemory(SAVE_FILE_NAME)) < 0) {
		*tip = 20;
		*bet = 4;
		*count = 0;
		return FALSE;
	}

	Bfile_ReadFile(h, tip, sizeof(*tip), sizeof(int) * 0);
	Bfile_ReadFile(h, bet, sizeof(*bet), sizeof(int) * 1);
	Bfile_ReadFile(h, count, sizeof(*count), sizeof(int) * 2);

	Bfile_CloseFile(h);

	return TRUE;
}

/*
	Q[Ԃۑ
*/
void store(int tip, int bet, int count)
{
	int h;

	if((h = Bfile_OpenMainMemory(SAVE_FILE_NAME)) < 0) {
		Bfile_CreateMainMemory(SAVE_FILE_NAME);
		if((h = Bfile_OpenMainMemory(SAVE_FILE_NAME)) < 0)
			return;
	}

	Bfile_WriteFile(h, &tip, sizeof(tip));
	Bfile_WriteFile(h, &bet, sizeof(bet));
	Bfile_WriteFile(h, &count, sizeof(count));

	Bfile_CloseFile(h);
}

/*
	Q[Ԃ폜
*/
void delete(void)
{
	Bfile_DeleteMainMemory(SAVE_FILE_NAME);
}

/*
	V[h𐶐 ()
*/
void incSeed(void)
{
	seed++;
}

/*
	V[h߂
*/
int getSeed(void)
{
	return seed;
}

/*
	Q[I
*/
int quit(void)
{
	KillTimer(ID_USER_TIMER1);
}

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int AddIn_main(int isAppli, unsigned short OptionNum)
{
	SetTimer(ID_USER_TIMER1, 25, incSeed);
	SetQuitHandler(quit);
	mainLoop();

	return 1;
}

//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

/*
	Copyright 2010 maruhiro
	All rights reserved. 

	Redistribution and use in source and binary forms, 
	with or without modification, are permitted provided that 
	the following conditions are met: 

	 1. Redistributions of source code must retain the above copyright notice, 
	    this list of conditions and the following disclaimer. 

	 2. Redistributions in binary form must reproduce the above copyright notice, 
	    this list of conditions and the following disclaimer in the documentation 
	    and/or other materials provided with the distribution. 

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
	FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
	THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
	OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
	ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/* eof */